#include <stdint.h>

typedef uint32_t u32;


u32 bitcount(u32 pattern);

void saveState(u32 ns1, u32 ns2, u32 nbit, const u32 sequence[]);

// Saves if it's needed (dep on time interval and progress).
void checkSave(u32 ns1, u32 ns2, u32 nbit, u32 score, const u32 sequence[]); 

void setBest(u32 bestscore);


bool attemptRestoreState(u32 ns1, u32 ns2, u32 nbit, u32 sequence[]);

bool solutionQualityCheck(u32 ns1, u32 ns2, u32 nbit, const u32 sequence[]);

void storeSolution(u32 ns1, u32 ns2, u32 nbit, const u32 sequence[]);

void fetchArguments(int argc, char *argv[], u32 &nsymbols1, u32 &nsymbols2, u32 &nbit, u32 &randomweight, u32 &rebalance_count, bool &use_fixed_seed);
